import { MdcComponent } from '@aurelia2-mdc-web/base';
import { MDCMenuSurfaceFoundation, Corner, MDCMenuDistance } from '@material/menu-surface';
export declare class MdcMenuSurface extends MdcComponent<MDCMenuSurfaceFoundation> implements EventListenerObject {
    originalParent: HTMLElement | null;
    private previousFocus?;
    anchor?: Element | null;
    /** Sets the foundation to use page offsets for an positioning when the menu is hoisted to the body. */
    hoistToBody: boolean;
    fixed: boolean;
    fixedChanged(): Promise<void>;
    anchorCorner: keyof typeof Corner;
    anchorCornerChanged(): Promise<void>;
    anchorMargin: Partial<MDCMenuDistance>;
    anchorMarginChanged(margin: Partial<MDCMenuDistance>): Promise<void>;
    quickOpen: boolean;
    quickOpenChanged(quickOpen: boolean): Promise<void>;
    fullWidth: boolean;
    fullWidthChanged(): void;
    stayOpen: boolean;
    maxHeight: number;
    maxHeightChanged(): Promise<void>;
    horizontallyCenteredOnViewport: boolean;
    horizontallyCenteredOnViewportChanged(): Promise<void>;
    openBottomBias: number;
    openBottomBiasChanged(): Promise<void>;
    get open(): boolean;
    set open(value: boolean);
    handleKeydown(evt: KeyboardEvent): void;
    handleBodyClick(evt: MouseEvent): void;
    initialise(): Promise<void>;
    handleEvent(evt: Event): void;
    registerBodyClickListener(): void;
    deregisterBodyClickListener(): void;
    initialSyncWithDOM(): void;
    destroy(): void;
    close(skipRestoreFocus?: boolean): void;
    /** Sets the absolute x/y position to position based on. Requires the menu to be hoisted. */
    setAbsolutePosition(x: number, y: number): void;
    /**
     * @param corner Default anchor corner alignment of top-left surface corner.
     */
    setAnchorCorner(corner: Corner): void;
    getDefaultFoundation(): MDCMenuSurfaceFoundation;
}
